#include <QApplication>
#include <QWidget>
#include <QWindow>
#include <QSlider>
#include <QLineEdit>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QDebug>
#include <QEvent>

class TestWidget : public QWidget
{
    Q_OBJECT

public:
    explicit TestWidget(QWidget *parent = 0);

protected:
    virtual bool eventFilter(QObject *source, QEvent *event);

private:
    QWindow * m_window;
    QWidget * m_container;
};

TestWidget::TestWidget(QWidget *parent) :  QWidget(parent)

{
    setWindowTitle(QT_VERSION_STR);
    QVBoxLayout *lt = new QVBoxLayout(this);
    QSlider *sl = new QSlider(Qt::Horizontal);
    sl->setFocusPolicy( Qt::StrongFocus );
    lt->addWidget(sl);
    m_window = new QWindow();
    m_container = createWindowContainer( m_window, this );
    m_container->setMinimumSize(200, 200);
    m_container->setFocusPolicy( Qt::StrongFocus );
    lt->addWidget(m_container);

    sl->installEventFilter( this );
    m_window->installEventFilter( this );
}

bool TestWidget::eventFilter(QObject *source, QEvent *event)
{
    if( event->type() == QEvent::FocusIn )
        qDebug() << "focusIn" << source;

    if( event->type() == QEvent::FocusOut )
        qDebug() << "focusOut" << source;

    return false;
}

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	TestWidget w;
    w.move(400, 400);
	w.show();

	return a.exec();
}

#include "main.moc"
